using System;
using System.Collections.Generic;
using System.Threading;

namespace Cluster.Famicom.Mappers
{
    public class AxROM : IMapper
    {
        public string Name
        {
            get { return "AxROM_BT"; }
        }

        public int Number
        {
            get { return 7; }
        }

        public string UnifName
        {
            get { return null; }
        }

        public int DefaultPrgSize
        {
            get { return 2 * 1024 * 1024; }
        }

        public int DefaultChrSize
        {
            get { return 0; }
        }

        public void DumpPrg(FamicomDumperConnection dumper, List<byte> data, int size)
        {
			int banks = size / 0x40000;
			
			for (int bankh = 0; bankh < banks; bankh++)
			{
				dumper.WriteCpu((ushort)(0x8000), (byte)bankh);
				
				for (int bankl = 0; bankl < 8; bankl++)
				{
					Console.Write("Read PRG bank #{0}... ", bankh*8+bankl);
					dumper.WriteCpu((ushort)(0xC000), (byte)bankl);
					data.AddRange(dumper.ReadCpu(0x8000, 0x8000));
					Console.WriteLine("OK");
				}
			}
        }

        public void DumpChr(FamicomDumperConnection dumper, List<byte> data, int size)
        {
            return;
        }
        public void EnablePrgRam(FamicomDumperConnection dumper)
        {
            Console.WriteLine("Warning: SRAM is not supported by this mapper");
        }
    }
}
